<link rel="import" href="/extern/bower_components/polymer/polymer.html">
<link rel="import" href="/extern/bower_components/paper-button/paper-button.html">
<link rel="import" href="/extern/bower_components/iron-ajax/iron-ajax.html">
<link rel="import" href="/extern/bower_components/paper-icon-button/paper-icon-button.html">
<link rel="import" href="/extern/bower_components/paper-dialog/paper-dialog.html">
<link rel="import" href="/ts/common-elements/reset-css/reset-css.html">
<link rel="import" href="/ts/common-elements/iron-flex-layout-attributes/iron-flex-layout-attributes.html">
<link rel="import" href="/ts/ajaxell/html/elements/ajaxell-icons/ajaxell-icons.html">
<link rel="import" href="/extern/bower_components/iron-icon/iron-icon.html">
<link rel="import" href="/extern/bower_components/iron-icons/iron-icons.html">

<link rel="import" href="/ts/common-elements/auto-update/auto-update.html">
<link rel="import" href="/ts/common-elements/ts-ajax/ts-ajax.html">
<link rel="import" href="/ts/common-elements/command-input/command-input.html">

<!--
only the last comment before <dom-module ...> appears in the documentation
-->

<!--
Material design: [Click me](https://www.google.com/design/spec/components/text-fields.html)

`ts-operations` is a template to be used when creating new Agilians elements.

Example:

    <ts-operations></ts-operations>
    <ts-operations demo-text="test"></ts-operations>

### Styling
The following custom properties and mixins are available for styling:

Custom property | Description | Default
----------------|-------------|----------
`--test-color` | A custom css property | `black`
`--ts-operations-mixin` | A custom mixin | `{}`

@demo demo/index.html

-->

<dom-module id="ts-operations">
  <template>
    <style>
:host{display:block}command-input{min-width:170px;margin:5px}auto-update{display:inline-block;margin:5px 0;margin-bottom:1em}paper-button[command="reset"]{background-color:var(--paper-deep-orange-500, red)}iron-icon{height:48px;width:48px}section[horizontal-dots]{margin:1em 0;padding:1em 0;border-top:1px dashed #E0E0E0}section[vertical-dots]{padding-right:15px;padding-left:10px;padding-top:8px;border-right:1px dashed #E0E0E0}section[push-down]{margin-top:1em}[horizontal][layout] [flex]>section{padding-left:1em}#result[result-type="busy"]{color:var(--paper-grey-500, gray)}#result[result-type="info"]{color:var(--paper-blue-800, blue)}#result[result-type="warning"]{color:var(--paper-orange-800, orange)}#result[result-type="error"]{color:var(--paper-red-800, red)}

</style>
    <style include="reset-css"></style>
    <style include="iron-flex-layout-attributes"></style>

    <section horizontal layout>
      <section vertical-dots>
        <ts-ajax data="{{_inputs}}" callback="getInputs" handle-as="json" auto></ts-ajax>
        <template is="dom-repeat" items="{{_inputs}}" as="input" sort="_sortInput">
          <command-input name=[[input.name]] type=[[input.type]] value={{input.value}} always-float-label></command-input><br>
        </template>
      </section>
      <section flex>
        <section push-down>
          <template is="dom-repeat" items="[[commands]]" as="command">
            <paper-button raised on-click="_execute" command$="[[command]]">[[command]]</paper-button>
          </template>
          <paper-button raised on-click="_execute" command="reset">reset</paper-button>
          <paper-icon-button icon="ajaxell:operations" on-click="_getSVG"></paper-icon-button>
          <ts-ajax id="ajax_commands" data="{{commands}}" callback="getCommands" handle-as="json"></ts-ajax>

          <ts-ajax id="svgajax" data="{{_svg}}" callback="getGraph" handle-as="text" interval="0"></ts-ajax>
          <paper-dialog id="svg">
          </paper-dialog>
        </section>

        <section horizontal-dots>
          <auto-update id="update_result" data="{{_result}}" callback="getResult" handle-as="json" interval="0"></auto-update>
          <div id="result" flex></div>
        </section>
      </section>
    </section>

    <iron-ajax id="execute" url="" method="post" handle-as="json" on-response="_commandResponse"></iron-ajax>




  </template>
  <script>
Polymer({is:"ts-operations",properties:{_svg:{type:String,observer:"_setSVG"},_result:{type:Object,observer:"_resultChanged"},_inputs:{type:Array,observer:"_inputsChanged"},busy:{type:Boolean,value:!1}},_sortInput:function(a,b){var ba=this._isBoolean(a),bb=this._isBoolean(b);return ba&&!bb?-1:!ba&&bb?1:0},_getSVG:function(){this.$.svg.open(),this.$.svgajax.generateRequest()},_setSVG:function(){Polymer.dom(this.$.svg).innerHTML=this._svg},_isBoolean:function(item){return"boolean"==item.type.toLowerCase()||"bool"==item.type.toLowerCase()},_execute:function(e){var ajax=this.$.execute,params={_eventType_:"OnSubmit",_id_:"execute",command:e.model?e.model.command:"reset"};if(this._inputs)for(var i=0;i<this._inputs.length;i++){var currentParameter=this._inputs[i];params[currentParameter.name]=currentParameter.value}ajax.params=params,ajax.generateRequest(),this.set("busy",!0),console.log("set T=1000"),this.$.update_result.set("interval",1e3)},_resultChanged:function(newval,oldval){this.$.ajax_commands.generateRequest(),"undefined"!=typeof oldval&&(Polymer.dom(this.$.result).setAttribute("result-type",this._result.type),Polymer.dom(this.$.result).innerHTML=this._result.value,"busy"!=this._result.type&&(this.set("busy",!1),console.log("set T=5000"),this.$.update_result.set("interval",5e3)))},_inputsChanged:function(){console.log("inputs changed"),this.$.update_result.generateRequest()},_commandResponse:function(){}});
</script>
</dom-module>
